# Minimal OS4 "Hello World"
# Written by Frank Wille, December 2011
# Adapted to GCCs syntax by kas1e, Febrary 2012


# ExecBase
.set	ExecBase,4
.set	MainInterface,632

# Exec Interface
.set	Obtain,60
.set	Release,64
.set	OpenLibrary,424
.set	CloseLibrary,428
.set	GetInterface,448
.set	DropInterface,456

# DOS Interface
.set	Write,88
.set	Output,96



.macro CALLOS reg,val   # Interface register, function offset
	lwz %r0,\val(\reg)
	mr %r3,\reg
	mtctr %r0
	bctrl
.endm


	.text

	.global	_start
_start:

	mflr	%r0
	stwu	%r1,-32(%r1)
	stmw	%r28,8(%r1)
	mr	%r31,%r0

	# get SysBase
	li	%r11,ExecBase
	lwz	%r3,0(%r11)

	# get Exec-Interface
	lwz	%r30,MainInterface(%r3)	# r30 IExec

	# IExec->Obtain()
	CALLOS	%r30,Obtain

	# open dos.library and get DOS-Interface
	# IExec->OpenLibrary("dos.library",50)
	lis	%r4,dos_name@ha
	addi	%r4,%r4,dos_name@l
	li	%r5,50
	CALLOS	%r30,OpenLibrary
	mr.	%r28,%r3			# r28 DOSBase
	beq	release_exec

	# IExec->GetInterface(DOSBase,"main",1,0)
	mr	%r4,%r28
	lis	%r5,main_name@ha
	addi	%r5,%r5,main_name@l
	li	%r6,1
	li	%r7,0
	CALLOS	%r30,GetInterface
	mr.	%r29,%r3			# r29 IDOS
	beq	close_dos

	# IDOS->Output()
	CALLOS	%r29,Output

	# IDOS->Write(stdout,"Hello World!\n",13)
	mr	%r4,%r3
	lis	%r5,hello_world@ha
	addi	%r5,%r5,hello_world@l
	li	%r6,hello_world_end-hello_world
	CALLOS	%r29,Write

	# IExec->DropInterface(IDOS)
	mr	%r4,%r29
	CALLOS	%r30,DropInterface

close_dos:
	# IExec->CloseLibrary(DOSBase)
	mr	%r4,%r28
	CALLOS	%r30,CloseLibrary

release_exec:
	# IExec->Release()
	CALLOS	%r30,Release

	# exit(0)
	li	%r3,0
	mtlr	%r31
	lmw	%r28,8(%r1)
	addi	%r1,%r1,32
	blr


	.rodata

dos_name:
	.string	"dos.library"
main_name:
	.string	"main"
hello_world:
#	.byte	"Hello World!",10
   .string "Hello World!"
hello_world_end:
